/* ContractMatcher.c generated by valac 0.56.17, the Vala compiler
 * generated from ContractMatcher.vala, do not modify */

/*
 * Copyright (C) 2011-2017 elementary Developers
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define CONTRACTOR_TYPE_CONTRACT (contractor_contract_get_type ())
#define CONTRACTOR_CONTRACT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONTRACTOR_TYPE_CONTRACT, ContractorContract))
#define CONTRACTOR_CONTRACT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONTRACTOR_TYPE_CONTRACT, ContractorContractClass))
#define CONTRACTOR_IS_CONTRACT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONTRACTOR_TYPE_CONTRACT))
#define CONTRACTOR_IS_CONTRACT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONTRACTOR_TYPE_CONTRACT))
#define CONTRACTOR_CONTRACT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONTRACTOR_TYPE_CONTRACT, ContractorContractClass))

typedef struct _ContractorContract ContractorContract;
typedef struct _ContractorContractClass ContractorContractClass;

#define CONTRACTOR_TYPE_CONTRACTOR_ERROR (contractor_contractor_error_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

typedef enum  {
	CONTRACTOR_CONTRACTOR_ERROR_NO_MIMETYPES_GIVEN
} ContractorContractorError;
#define CONTRACTOR_CONTRACTOR_ERROR contractor_contractor_error_quark ()

VALA_EXTERN GType contractor_contract_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ContractorContract, g_object_unref)
VALA_EXTERN GQuark contractor_contractor_error_quark (void);
VALA_EXTERN GType contractor_contractor_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GeeCollection* contractor_contract_matcher_get_contracts_for_types (gchar** mime_types,
                                                                    gint mime_types_length1,
                                                                    GeeCollection* contracts_to_filter,
                                                                    GError** error);
VALA_EXTERN gchar** contractor_string_clean_array (gchar** str_array,
                                       gint str_array_length1,
                                       gint* result_length1);
VALA_EXTERN gboolean contractor_contract_supports_mime_type (ContractorContract* self,
                                                 const gchar* mime_type);
VALA_EXTERN GeeCollection* contractor_contract_matcher_get_contracts_for_file_size (gint64 file_size,
                                                                        GeeCollection* contracts_to_filter,
                                                                        GError** error);
VALA_EXTERN gboolean contractor_contract_supports_file_size (ContractorContract* self,
                                                 gint64 file_size);
VALA_EXTERN GeeCollection* contractor_contract_matcher_get_contracts_for_types_and_file_size (gchar** mime_types,
                                                                                  gint mime_types_length1,
                                                                                  gint64 file_size,
                                                                                  GeeCollection* contracts_to_filter,
                                                                                  GError** error);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

/**
     * get contracts which support the passed MIME types
     *
     * @param mime_types the MIME types which have to be supported by the returned contracts
     * @param contracts_to_filter a list of contracts to filter
     *
     * @return a Collection of Contract objects which support the file size
     */
GeeCollection*
contractor_contract_matcher_get_contracts_for_types (gchar** mime_types,
                                                     gint mime_types_length1,
                                                     GeeCollection* contracts_to_filter,
                                                     GError** error)
{
	GeeLinkedList* valid_contracts = NULL;
	GeeLinkedList* _tmp0_;
	gchar** valid_mime_types = NULL;
	gint _tmp1_ = 0;
	gchar** _tmp2_;
	gint valid_mime_types_length1;
	gint _valid_mime_types_size_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	GError* _inner_error0_ = NULL;
	GeeCollection* result;
#line 27 "../src/ContractMatcher.vala"
	g_return_val_if_fail (contracts_to_filter != NULL, NULL);
#line 30 "../src/ContractMatcher.vala"
	_tmp0_ = gee_linked_list_new (CONTRACTOR_TYPE_CONTRACT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 30 "../src/ContractMatcher.vala"
	valid_contracts = _tmp0_;
#line 31 "../src/ContractMatcher.vala"
	_tmp2_ = contractor_string_clean_array (mime_types, (gint) mime_types_length1, &_tmp1_);
#line 31 "../src/ContractMatcher.vala"
	valid_mime_types = _tmp2_;
#line 31 "../src/ContractMatcher.vala"
	valid_mime_types_length1 = _tmp1_;
#line 31 "../src/ContractMatcher.vala"
	_valid_mime_types_size_ = valid_mime_types_length1;
#line 33 "../src/ContractMatcher.vala"
	_tmp3_ = valid_mime_types;
#line 33 "../src/ContractMatcher.vala"
	_tmp3__length1 = valid_mime_types_length1;
#line 33 "../src/ContractMatcher.vala"
	if (_tmp3__length1 == 0) {
#line 140 "ContractMatcher.c"
		GError* _tmp4_;
#line 34 "../src/ContractMatcher.vala"
		_tmp4_ = g_error_new_literal (CONTRACTOR_CONTRACTOR_ERROR, CONTRACTOR_CONTRACTOR_ERROR_NO_MIMETYPES_GIVEN, "No mimetypes were provided.");
#line 34 "../src/ContractMatcher.vala"
		_inner_error0_ = _tmp4_;
#line 34 "../src/ContractMatcher.vala"
		if (_inner_error0_->domain == CONTRACTOR_CONTRACTOR_ERROR) {
#line 34 "../src/ContractMatcher.vala"
			g_propagate_error (error, _inner_error0_);
#line 34 "../src/ContractMatcher.vala"
			valid_mime_types = (_vala_array_free (valid_mime_types, valid_mime_types_length1, (GDestroyNotify) g_free), NULL);
#line 34 "../src/ContractMatcher.vala"
			_g_object_unref0 (valid_contracts);
#line 34 "../src/ContractMatcher.vala"
			return NULL;
#line 156 "ContractMatcher.c"
		} else {
#line 34 "../src/ContractMatcher.vala"
			valid_mime_types = (_vala_array_free (valid_mime_types, valid_mime_types_length1, (GDestroyNotify) g_free), NULL);
#line 34 "../src/ContractMatcher.vala"
			_g_object_unref0 (valid_contracts);
#line 34 "../src/ContractMatcher.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 34 "../src/ContractMatcher.vala"
			g_clear_error (&_inner_error0_);
#line 34 "../src/ContractMatcher.vala"
			return NULL;
#line 168 "ContractMatcher.c"
		}
	}
	{
		GeeIterator* _contract_it = NULL;
		GeeIterator* _tmp5_;
#line 37 "../src/ContractMatcher.vala"
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) contracts_to_filter);
#line 37 "../src/ContractMatcher.vala"
		_contract_it = _tmp5_;
#line 37 "../src/ContractMatcher.vala"
		while (TRUE) {
#line 180 "ContractMatcher.c"
			GeeIterator* _tmp6_;
			ContractorContract* contract = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			gboolean all_types_supported = FALSE;
			gchar** _tmp9_;
			gint _tmp9__length1;
#line 37 "../src/ContractMatcher.vala"
			_tmp6_ = _contract_it;
#line 37 "../src/ContractMatcher.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 37 "../src/ContractMatcher.vala"
				break;
#line 194 "ContractMatcher.c"
			}
#line 37 "../src/ContractMatcher.vala"
			_tmp7_ = _contract_it;
#line 37 "../src/ContractMatcher.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 37 "../src/ContractMatcher.vala"
			contract = (ContractorContract*) _tmp8_;
#line 39 "../src/ContractMatcher.vala"
			all_types_supported = TRUE;
#line 41 "../src/ContractMatcher.vala"
			_tmp9_ = valid_mime_types;
#line 41 "../src/ContractMatcher.vala"
			_tmp9__length1 = valid_mime_types_length1;
#line 208 "ContractMatcher.c"
			{
				gchar** mime_type_collection = NULL;
				gint mime_type_collection_length1 = 0;
				gint _mime_type_collection_size_ = 0;
				gint mime_type_it = 0;
#line 41 "../src/ContractMatcher.vala"
				mime_type_collection = _tmp9_;
#line 41 "../src/ContractMatcher.vala"
				mime_type_collection_length1 = _tmp9__length1;
#line 41 "../src/ContractMatcher.vala"
				for (mime_type_it = 0; mime_type_it < mime_type_collection_length1; mime_type_it = mime_type_it + 1) {
#line 220 "ContractMatcher.c"
					gchar* _tmp10_;
					gchar* mime_type = NULL;
#line 41 "../src/ContractMatcher.vala"
					_tmp10_ = g_strdup (mime_type_collection[mime_type_it]);
#line 41 "../src/ContractMatcher.vala"
					mime_type = _tmp10_;
#line 227 "ContractMatcher.c"
					{
						ContractorContract* _tmp11_;
						const gchar* _tmp12_;
#line 42 "../src/ContractMatcher.vala"
						_tmp11_ = contract;
#line 42 "../src/ContractMatcher.vala"
						_tmp12_ = mime_type;
#line 42 "../src/ContractMatcher.vala"
						if (!contractor_contract_supports_mime_type (_tmp11_, _tmp12_)) {
#line 43 "../src/ContractMatcher.vala"
							all_types_supported = FALSE;
#line 44 "../src/ContractMatcher.vala"
							_g_free0 (mime_type);
#line 44 "../src/ContractMatcher.vala"
							break;
#line 243 "ContractMatcher.c"
						}
#line 41 "../src/ContractMatcher.vala"
						_g_free0 (mime_type);
#line 247 "ContractMatcher.c"
					}
				}
			}
#line 48 "../src/ContractMatcher.vala"
			if (all_types_supported) {
#line 253 "ContractMatcher.c"
				GeeLinkedList* _tmp13_;
				ContractorContract* _tmp14_;
#line 49 "../src/ContractMatcher.vala"
				_tmp13_ = valid_contracts;
#line 49 "../src/ContractMatcher.vala"
				_tmp14_ = contract;
#line 49 "../src/ContractMatcher.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp13_, _tmp14_);
#line 262 "ContractMatcher.c"
			}
#line 37 "../src/ContractMatcher.vala"
			_g_object_unref0 (contract);
#line 266 "ContractMatcher.c"
		}
#line 37 "../src/ContractMatcher.vala"
		_g_object_unref0 (_contract_it);
#line 270 "ContractMatcher.c"
	}
#line 53 "../src/ContractMatcher.vala"
	result = (GeeCollection*) valid_contracts;
#line 53 "../src/ContractMatcher.vala"
	valid_mime_types = (_vala_array_free (valid_mime_types, valid_mime_types_length1, (GDestroyNotify) g_free), NULL);
#line 53 "../src/ContractMatcher.vala"
	return result;
#line 278 "ContractMatcher.c"
}

/**
     * get contracts which support the passed file size
     *
     * @param file_size the file size which has to be supported by the returned contracts
     * @param contracts_to_filter a list of contracts to filter
     *
     * @return a Collection of Contract objects which support the file size
     */
GeeCollection*
contractor_contract_matcher_get_contracts_for_file_size (gint64 file_size,
                                                         GeeCollection* contracts_to_filter,
                                                         GError** error)
{
	GeeLinkedList* valid_contracts = NULL;
	GeeLinkedList* _tmp0_;
	GeeCollection* result;
#line 64 "../src/ContractMatcher.vala"
	g_return_val_if_fail (contracts_to_filter != NULL, NULL);
#line 67 "../src/ContractMatcher.vala"
	_tmp0_ = gee_linked_list_new (CONTRACTOR_TYPE_CONTRACT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 67 "../src/ContractMatcher.vala"
	valid_contracts = _tmp0_;
#line 303 "ContractMatcher.c"
	{
		GeeIterator* _contract_it = NULL;
		GeeIterator* _tmp1_;
#line 69 "../src/ContractMatcher.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) contracts_to_filter);
#line 69 "../src/ContractMatcher.vala"
		_contract_it = _tmp1_;
#line 69 "../src/ContractMatcher.vala"
		while (TRUE) {
#line 313 "ContractMatcher.c"
			GeeIterator* _tmp2_;
			ContractorContract* contract = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			gboolean file_size_supported = FALSE;
			ContractorContract* _tmp5_;
#line 69 "../src/ContractMatcher.vala"
			_tmp2_ = _contract_it;
#line 69 "../src/ContractMatcher.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 69 "../src/ContractMatcher.vala"
				break;
#line 326 "ContractMatcher.c"
			}
#line 69 "../src/ContractMatcher.vala"
			_tmp3_ = _contract_it;
#line 69 "../src/ContractMatcher.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 69 "../src/ContractMatcher.vala"
			contract = (ContractorContract*) _tmp4_;
#line 70 "../src/ContractMatcher.vala"
			file_size_supported = TRUE;
#line 72 "../src/ContractMatcher.vala"
			_tmp5_ = contract;
#line 72 "../src/ContractMatcher.vala"
			if (!contractor_contract_supports_file_size (_tmp5_, file_size)) {
#line 73 "../src/ContractMatcher.vala"
				file_size_supported = FALSE;
#line 342 "ContractMatcher.c"
			}
#line 76 "../src/ContractMatcher.vala"
			if (file_size_supported) {
#line 346 "ContractMatcher.c"
				GeeLinkedList* _tmp6_;
				ContractorContract* _tmp7_;
#line 77 "../src/ContractMatcher.vala"
				_tmp6_ = valid_contracts;
#line 77 "../src/ContractMatcher.vala"
				_tmp7_ = contract;
#line 77 "../src/ContractMatcher.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp6_, _tmp7_);
#line 355 "ContractMatcher.c"
			}
#line 69 "../src/ContractMatcher.vala"
			_g_object_unref0 (contract);
#line 359 "ContractMatcher.c"
		}
#line 69 "../src/ContractMatcher.vala"
		_g_object_unref0 (_contract_it);
#line 363 "ContractMatcher.c"
	}
#line 80 "../src/ContractMatcher.vala"
	result = (GeeCollection*) valid_contracts;
#line 80 "../src/ContractMatcher.vala"
	return result;
#line 369 "ContractMatcher.c"
}

/**
     * get contracts which support the passed MIME types and file size
     *
     * @param mime_types the MIME types which have to be supported by the returned contracts
     * @param file_size the file size which has to be supported by the returned contracts
     * @param contracts_to_filter a list of contracts to filter
     *
     * @return a Collection of Contract objects which support the MIME types and the file size
     */
GeeCollection*
contractor_contract_matcher_get_contracts_for_types_and_file_size (gchar** mime_types,
                                                                   gint mime_types_length1,
                                                                   gint64 file_size,
                                                                   GeeCollection* contracts_to_filter,
                                                                   GError** error)
{
	GeeCollection* contracts_for_types = NULL;
	GeeCollection* _tmp0_;
	GeeCollection* valid_contracts = NULL;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
	GError* _inner_error0_ = NULL;
	GeeCollection* result;
#line 92 "../src/ContractMatcher.vala"
	g_return_val_if_fail (contracts_to_filter != NULL, NULL);
#line 95 "../src/ContractMatcher.vala"
	_tmp0_ = contractor_contract_matcher_get_contracts_for_types (mime_types, (gint) mime_types_length1, contracts_to_filter, &_inner_error0_);
#line 95 "../src/ContractMatcher.vala"
	contracts_for_types = _tmp0_;
#line 95 "../src/ContractMatcher.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 95 "../src/ContractMatcher.vala"
		if (_inner_error0_->domain == CONTRACTOR_CONTRACTOR_ERROR) {
#line 95 "../src/ContractMatcher.vala"
			g_propagate_error (error, _inner_error0_);
#line 95 "../src/ContractMatcher.vala"
			return NULL;
#line 409 "ContractMatcher.c"
		} else {
#line 95 "../src/ContractMatcher.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 95 "../src/ContractMatcher.vala"
			g_clear_error (&_inner_error0_);
#line 95 "../src/ContractMatcher.vala"
			return NULL;
#line 417 "ContractMatcher.c"
		}
	}
#line 96 "../src/ContractMatcher.vala"
	_tmp1_ = contracts_for_types;
#line 96 "../src/ContractMatcher.vala"
	_tmp2_ = contractor_contract_matcher_get_contracts_for_file_size (file_size, _tmp1_, &_inner_error0_);
#line 96 "../src/ContractMatcher.vala"
	valid_contracts = _tmp2_;
#line 96 "../src/ContractMatcher.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 96 "../src/ContractMatcher.vala"
		if (_inner_error0_->domain == CONTRACTOR_CONTRACTOR_ERROR) {
#line 96 "../src/ContractMatcher.vala"
			g_propagate_error (error, _inner_error0_);
#line 96 "../src/ContractMatcher.vala"
			_g_object_unref0 (contracts_for_types);
#line 96 "../src/ContractMatcher.vala"
			return NULL;
#line 436 "ContractMatcher.c"
		} else {
#line 96 "../src/ContractMatcher.vala"
			_g_object_unref0 (contracts_for_types);
#line 96 "../src/ContractMatcher.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 96 "../src/ContractMatcher.vala"
			g_clear_error (&_inner_error0_);
#line 96 "../src/ContractMatcher.vala"
			return NULL;
#line 446 "ContractMatcher.c"
		}
	}
#line 98 "../src/ContractMatcher.vala"
	result = valid_contracts;
#line 98 "../src/ContractMatcher.vala"
	_g_object_unref0 (contracts_for_types);
#line 98 "../src/ContractMatcher.vala"
	return result;
#line 455 "ContractMatcher.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

